/* This file was generated by SableCC (http://www.sablecc.org/). */

package de.be4.classicalb.core.parser.lexer;

import java.io.*;
import java.util.*;
import de.be4.classicalb.core.parser.node.*;
import de.hhu.stups.sablecc.patch.*;


@SuppressWarnings({"unused"}) 
public class Lexer implements ITokenListContainer
{
    protected Token token;
    protected State state = State.NORMAL;

    private PushbackReader in;
    private int line;
    private int pos;
    private boolean cr;
    private boolean eof;
    private final StringBuffer text = new StringBuffer();
    
	private List<IToken> tokenList;

	private IToken tok;

	public List<IToken> getTokenList() {
		return tokenList;
	}
	
	private void setToken(Token t) {
	  tok = t;
   	  token = t;	
	}
	
	
	public void setTokenList(final List<IToken> list) {
		tokenList = list;
	}

     
    protected void filter() throws LexerException, IOException
    {
        // Do nothing
    }

    protected void filterWrap() throws LexerException, IOException
    {
       filter();
       if (token != null) {
	          getTokenList().add(token); 
	   }
    }


    public Lexer(  PushbackReader in)
    {
        this.in = in;
    	setTokenList(new ArrayList<IToken>());
    }
    
    public Token peek() throws LexerException, IOException
    {
        while(this.token == null)
        {
            this.setToken(getToken());
            filterWrap();
        }

        return this.token;
    }

    public Token next() throws LexerException, IOException
    {
        while(this.token == null)
        {
            this.setToken(getToken());
            filterWrap();
        }

        Token result = this.token;
        this.setToken(null);
        return result;
    }

    protected Token getToken() throws IOException, LexerException
    {
        int dfa_state = 0;

        int start_pos = this.pos;
        int start_line = this.line;

        int accept_state = -1;
        int accept_token = -1;
        int accept_length = -1;
        int accept_pos = -1;
        int accept_line = -1;

          int[][][] gotoTable = Lexer.gotoTable[this.state.id()];
          int[] accept = Lexer.accept[this.state.id()];
        this.text.setLength(0);

        while(true)
        {
            int c = getChar();

            if(c != -1)
            {
                switch(c)
                {
                case 10:
                    if(this.cr)
                    {
                        this.cr = false;
                    }
                    else
                    {
                        this.line++;
                        this.pos = 0;
                    }
                    break;
                case 13:
                    this.line++;
                    this.pos = 0;
                    this.cr = true;
                    break;
                default:
                    this.pos++;
                    this.cr = false;
                    break;
                }

                this.text.append((char) c);

                do
                {
                    int oldState = (dfa_state < -1) ? (-2 -dfa_state) : dfa_state;

                    dfa_state = -1;

                    int[][] tmp1 =  gotoTable[oldState];
                    int low = 0;
                    int high = tmp1.length - 1;

                    while(low <= high)
                    {
                        int middle = (low + high) / 2;
                        int[] tmp2 = tmp1[middle];

                        if(c < tmp2[0])
                        {
                            high = middle - 1;
                        }
                        else if(c > tmp2[1])
                        {
                            low = middle + 1;
                        }
                        else
                        {
                            dfa_state = tmp2[2];
                            break;
                        }
                    }
                }while(dfa_state < -1);
            }
            else
            {
                dfa_state = -1;
            }

            if(dfa_state >= 0)
            {
                if(accept[dfa_state] != -1)
                {
                    accept_state = dfa_state;
                    accept_token = accept[dfa_state];
                    accept_length = this.text.length();
                    accept_pos = this.pos;
                    accept_line = this.line;
                }
            }
            else
            {
                if(accept_state != -1)
                {
                    switch(accept_token)
                    {
                    case 0:
                        {
                              Token token = new0(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.SHEBANG; break;
                                case 1: state = State.SHEBANG; break;
                            }
                            return token;
                        }
                    case 1:
                        {
                              Token token = new1(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 2:
                        {
                              Token token = new2(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 1: state = State.SHEBANG; break;
                            }
                            return token;
                        }
                    case 3:
                        {
                              Token token = new3(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.COMMENT; break;
                                case 0: state = State.COMMENT; break;
                            }
                            return token;
                        }
                    case 4:
                        {
                              Token token = new4(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.COMMENT; break;
                            }
                            return token;
                        }
                    case 5:
                        {
                              Token token = new5(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.COMMENT; break;
                            }
                            return token;
                        }
                    case 6:
                        {
                              Token token = new6(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.COMMENT; break;
                            }
                            return token;
                        }
                    case 7:
                        {
                              Token token = new7(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 2: state = State.COMMENT; break;
                            }
                            return token;
                        }
                    case 8:
                        {
                              Token token = new8(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 9:
                        {
                              Token token = new9(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 10:
                        {
                              Token token = new10(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 11:
                        {
                              Token token = new11(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 12:
                        {
                              Token token = new12(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 13:
                        {
                              Token token = new13(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 14:
                        {
                              Token token = new14(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 15:
                        {
                              Token token = new15(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 16:
                        {
                              Token token = new16(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 17:
                        {
                              Token token = new17(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 18:
                        {
                              Token token = new18(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 19:
                        {
                              Token token = new19(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 20:
                        {
                              Token token = new20(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 21:
                        {
                              Token token = new21(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 22:
                        {
                              Token token = new22(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 23:
                        {
                              Token token = new23(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 24:
                        {
                              Token token = new24(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 25:
                        {
                              Token token = new25(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 26:
                        {
                              Token token = new26(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 27:
                        {
                              Token token = new27(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 28:
                        {
                              Token token = new28(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 29:
                        {
                              Token token = new29(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 30:
                        {
                              Token token = new30(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 31:
                        {
                              Token token = new31(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 32:
                        {
                              Token token = new32(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 33:
                        {
                              Token token = new33(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 34:
                        {
                              Token token = new34(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 35:
                        {
                              Token token = new35(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 36:
                        {
                              Token token = new36(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 37:
                        {
                              Token token = new37(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 38:
                        {
                              Token token = new38(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 39:
                        {
                              Token token = new39(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 40:
                        {
                              Token token = new40(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 41:
                        {
                              Token token = new41(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 42:
                        {
                              Token token = new42(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 43:
                        {
                              Token token = new43(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 44:
                        {
                              Token token = new44(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 45:
                        {
                              Token token = new45(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 46:
                        {
                              Token token = new46(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 47:
                        {
                              Token token = new47(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 48:
                        {
                              Token token = new48(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 49:
                        {
                              Token token = new49(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 50:
                        {
                              Token token = new50(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 51:
                        {
                              Token token = new51(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 52:
                        {
                              Token token = new52(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 53:
                        {
                              Token token = new53(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 54:
                        {
                              Token token = new54(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 55:
                        {
                              Token token = new55(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 56:
                        {
                              Token token = new56(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 57:
                        {
                              Token token = new57(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 58:
                        {
                              Token token = new58(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 59:
                        {
                              Token token = new59(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 60:
                        {
                              Token token = new60(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 61:
                        {
                              Token token = new61(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 62:
                        {
                              Token token = new62(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 63:
                        {
                              Token token = new63(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 64:
                        {
                              Token token = new64(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 65:
                        {
                              Token token = new65(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 66:
                        {
                              Token token = new66(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 67:
                        {
                              Token token = new67(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 68:
                        {
                              Token token = new68(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 69:
                        {
                              Token token = new69(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 70:
                        {
                              Token token = new70(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 71:
                        {
                              Token token = new71(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 72:
                        {
                              Token token = new72(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 73:
                        {
                              Token token = new73(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 74:
                        {
                              Token token = new74(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 75:
                        {
                              Token token = new75(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 76:
                        {
                              Token token = new76(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 77:
                        {
                              Token token = new77(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 78:
                        {
                              Token token = new78(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 79:
                        {
                              Token token = new79(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 80:
                        {
                              Token token = new80(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 81:
                        {
                              Token token = new81(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 82:
                        {
                              Token token = new82(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 83:
                        {
                              Token token = new83(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 84:
                        {
                              Token token = new84(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 85:
                        {
                              Token token = new85(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 86:
                        {
                              Token token = new86(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 87:
                        {
                              Token token = new87(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 88:
                        {
                              Token token = new88(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 89:
                        {
                              Token token = new89(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 90:
                        {
                              Token token = new90(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 91:
                        {
                              Token token = new91(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 92:
                        {
                              Token token = new92(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 93:
                        {
                              Token token = new93(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 94:
                        {
                              Token token = new94(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 95:
                        {
                              Token token = new95(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 96:
                        {
                              Token token = new96(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 97:
                        {
                              Token token = new97(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 98:
                        {
                              Token token = new98(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 99:
                        {
                              Token token = new99(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 100:
                        {
                              Token token = new100(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 101:
                        {
                              Token token = new101(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 102:
                        {
                              Token token = new102(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 103:
                        {
                              Token token = new103(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 104:
                        {
                              Token token = new104(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 105:
                        {
                              Token token = new105(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 106:
                        {
                              Token token = new106(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 107:
                        {
                              Token token = new107(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 108:
                        {
                              Token token = new108(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 109:
                        {
                              Token token = new109(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 110:
                        {
                              Token token = new110(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 111:
                        {
                              Token token = new111(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 112:
                        {
                              Token token = new112(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 113:
                        {
                              Token token = new113(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 114:
                        {
                              Token token = new114(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 115:
                        {
                              Token token = new115(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 116:
                        {
                              Token token = new116(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 117:
                        {
                              Token token = new117(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 118:
                        {
                              Token token = new118(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 119:
                        {
                              Token token = new119(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 120:
                        {
                              Token token = new120(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 121:
                        {
                              Token token = new121(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 122:
                        {
                              Token token = new122(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 123:
                        {
                              Token token = new123(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 124:
                        {
                              Token token = new124(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 125:
                        {
                              Token token = new125(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 126:
                        {
                              Token token = new126(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 127:
                        {
                              Token token = new127(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 128:
                        {
                              Token token = new128(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 129:
                        {
                              Token token = new129(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 130:
                        {
                              Token token = new130(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 131:
                        {
                              Token token = new131(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 132:
                        {
                              Token token = new132(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 133:
                        {
                              Token token = new133(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 134:
                        {
                              Token token = new134(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 135:
                        {
                              Token token = new135(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 136:
                        {
                              Token token = new136(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 137:
                        {
                              Token token = new137(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 138:
                        {
                              Token token = new138(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 139:
                        {
                              Token token = new139(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 140:
                        {
                              Token token = new140(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 141:
                        {
                              Token token = new141(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 142:
                        {
                              Token token = new142(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 143:
                        {
                              Token token = new143(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 144:
                        {
                              Token token = new144(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 145:
                        {
                              Token token = new145(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 146:
                        {
                              Token token = new146(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 147:
                        {
                              Token token = new147(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 148:
                        {
                              Token token = new148(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 149:
                        {
                              Token token = new149(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 150:
                        {
                              Token token = new150(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 151:
                        {
                              Token token = new151(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 152:
                        {
                              Token token = new152(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 153:
                        {
                              Token token = new153(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 154:
                        {
                              Token token = new154(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 155:
                        {
                              Token token = new155(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 156:
                        {
                              Token token = new156(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 157:
                        {
                              Token token = new157(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 158:
                        {
                              Token token = new158(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 159:
                        {
                              Token token = new159(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 160:
                        {
                              Token token = new160(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 161:
                        {
                              Token token = new161(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 162:
                        {
                              Token token = new162(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 163:
                        {
                              Token token = new163(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 164:
                        {
                              Token token = new164(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 165:
                        {
                              Token token = new165(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 166:
                        {
                              Token token = new166(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 167:
                        {
                              Token token = new167(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 168:
                        {
                              Token token = new168(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 169:
                        {
                              Token token = new169(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 170:
                        {
                              Token token = new170(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 171:
                        {
                              Token token = new171(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 172:
                        {
                              Token token = new172(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 173:
                        {
                              Token token = new173(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 174:
                        {
                              Token token = new174(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 175:
                        {
                              Token token = new175(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 176:
                        {
                              Token token = new176(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 177:
                        {
                              Token token = new177(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 178:
                        {
                              Token token = new178(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 179:
                        {
                              Token token = new179(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 180:
                        {
                              Token token = new180(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 181:
                        {
                              Token token = new181(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 182:
                        {
                              Token token = new182(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 183:
                        {
                              Token token = new183(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 184:
                        {
                              Token token = new184(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 185:
                        {
                              Token token = new185(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 186:
                        {
                              Token token = new186(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 187:
                        {
                              Token token = new187(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 188:
                        {
                              Token token = new188(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 189:
                        {
                              Token token = new189(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 190:
                        {
                              Token token = new190(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 191:
                        {
                              Token token = new191(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 192:
                        {
                              Token token = new192(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 193:
                        {
                              Token token = new193(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 194:
                        {
                              Token token = new194(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 195:
                        {
                              Token token = new195(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 196:
                        {
                              Token token = new196(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 197:
                        {
                              Token token = new197(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 198:
                        {
                              Token token = new198(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 199:
                        {
                              Token token = new199(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 200:
                        {
                              Token token = new200(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 201:
                        {
                              Token token = new201(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 202:
                        {
                              Token token = new202(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 203:
                        {
                              Token token = new203(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 204:
                        {
                              Token token = new204(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 205:
                        {
                              Token token = new205(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 206:
                        {
                              Token token = new206(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 207:
                        {
                              Token token = new207(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 208:
                        {
                              Token token = new208(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 209:
                        {
                              Token token = new209(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 210:
                        {
                              Token token = new210(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 211:
                        {
                              Token token = new211(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 212:
                        {
                              Token token = new212(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 213:
                        {
                              Token token = new213(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 214:
                        {
                              Token token = new214(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 215:
                        {
                              Token token = new215(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 216:
                        {
                              Token token = new216(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 217:
                        {
                              Token token = new217(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 218:
                        {
                              Token token = new218(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 219:
                        {
                              Token token = new219(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 220:
                        {
                              Token token = new220(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 221:
                        {
                              Token token = new221(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 222:
                        {
                              Token token = new222(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 223:
                        {
                              Token token = new223(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 224:
                        {
                              Token token = new224(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 225:
                        {
                              Token token = new225(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 226:
                        {
                              Token token = new226(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 227:
                        {
                              Token token = new227(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 228:
                        {
                              Token token = new228(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 229:
                        {
                              Token token = new229(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 230:
                        {
                              Token token = new230(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 231:
                        {
                              Token token = new231(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 232:
                        {
                              Token token = new232(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 233:
                        {
                              Token token = new233(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 234:
                        {
                              Token token = new234(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 235:
                        {
                              Token token = new235(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 236:
                        {
                              Token token = new236(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 237:
                        {
                              Token token = new237(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 238:
                        {
                              Token token = new238(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 239:
                        {
                              Token token = new239(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 240:
                        {
                              Token token = new240(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 241:
                        {
                              Token token = new241(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 242:
                        {
                              Token token = new242(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 243:
                        {
                              Token token = new243(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 244:
                        {
                              Token token = new244(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            switch(state.id())
                            {
                                case 0: state = State.NORMAL; break;
                            }
                            return token;
                        }
                    case 245:
                        {
                              Token token = new245(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            this.pos = accept_pos;
                            this.line = accept_line;
                            return token;
                        }
                    }
                }
                else
                {
                    if(this.text.length() > 0)
                    {
                        throw new LexerException(
                            "[" + (start_line + 1) + "," + (start_pos + 1) + "]" +
                            " Unknown token: " + this.text);
                    }

                      EOF token = new EOF(
                        start_line + 1,
                        start_pos + 1);
                    return token;
                }
            }
        }
    }

    Token new0(  int line,   int pos) { return new TShebang(line, pos); }
    Token new1(  String text,   int line,   int pos) { return new TShebangEnd(text, line, pos); }
    Token new2(  String text,   int line,   int pos) { return new TShebangChar(text, line, pos); }
    Token new3(  String text,   int line,   int pos) { return new TComment(text, line, pos); }
    Token new4(  String text,   int line,   int pos) { return new TCommentEnd(text, line, pos); }
    Token new5(  String text,   int line,   int pos) { return new TCommentBody(text, line, pos); }
    Token new6(  int line,   int pos) { return new TStar(line, pos); }
    Token new7(  int line,   int pos) { return new TSlash(line, pos); }
    Token new8(  String text,   int line,   int pos) { return new TStringLiteral(text, line, pos); }
    Token new9(  String text,   int line,   int pos) { return new TForAny(text, line, pos); }
    Token new10(  String text,   int line,   int pos) { return new TExists(text, line, pos); }
    Token new11(  int line,   int pos) { return new TDollar(line, pos); }
    Token new12(  String text,   int line,   int pos) { return new TLambda(text, line, pos); }
    Token new13(  String text,   int line,   int pos) { return new TConjunction(text, line, pos); }
    Token new14(  String text,   int line,   int pos) { return new TSingleQuotation(text, line, pos); }
    Token new15(  int line,   int pos) { return new TLeftPar(line, pos); }
    Token new16(  int line,   int pos) { return new TRightPar(line, pos); }
    Token new17(  String text,   int line,   int pos) { return new TProduct(text, line, pos); }
    Token new18(  int line,   int pos) { return new TPowerOf(line, pos); }
    Token new19(  String text,   int line,   int pos) { return new TPlus(text, line, pos); }
    Token new20(  String text,   int line,   int pos) { return new TPartialFunction(text, line, pos); }
    Token new21(  String text,   int line,   int pos) { return new TPartialSurjection(text, line, pos); }
    Token new22(  int line,   int pos) { return new TComma(line, pos); }
    Token new23(  String text,   int line,   int pos) { return new TMinus(text, line, pos); }
    Token new24(  String text,   int line,   int pos) { return new TTotalFunction(text, line, pos); }
    Token new25(  String text,   int line,   int pos) { return new TTotalSurjection(text, line, pos); }
    Token new26(  int line,   int pos) { return new TInsertStartSequence(line, pos); }
    Token new27(  int line,   int pos) { return new TDot(line, pos); }
    Token new28(  String text,   int line,   int pos) { return new TInterval(text, line, pos); }
    Token new29(  String text,   int line,   int pos) { return new TDotPar(text, line, pos); }
    Token new30(  int line,   int pos) { return new TDivision(line, pos); }
    Token new31(  String text,   int line,   int pos) { return new TNotBelonging(text, line, pos); }
    Token new32(  String text,   int line,   int pos) { return new TNonInclusion(text, line, pos); }
    Token new33(  String text,   int line,   int pos) { return new TStrictNonInclusion(text, line, pos); }
    Token new34(  String text,   int line,   int pos) { return new TNotEqual(text, line, pos); }
    Token new35(  int line,   int pos) { return new TSetSubtraction(line, pos); }
    Token new36(  String text,   int line,   int pos) { return new TIntersection(text, line, pos); }
    Token new37(  int line,   int pos) { return new TRestrictHeadSequence(line, pos); }
    Token new38(  String text,   int line,   int pos) { return new TElementOf(text, line, pos); }
    Token new39(  int line,   int pos) { return new TDoubleColon(line, pos); }
    Token new40(  int line,   int pos) { return new TAssign(line, pos); }
    Token new41(  int line,   int pos) { return new TSemicolon(line, pos); }
    Token new42(  int line,   int pos) { return new TLess(line, pos); }
    Token new43(  String text,   int line,   int pos) { return new TOverwriteRelation(text, line, pos); }
    Token new44(  String text,   int line,   int pos) { return new TSetRelation(text, line, pos); }
    Token new45(  int line,   int pos) { return new TInsertEndSequence(line, pos); }
    Token new46(  int line,   int pos) { return new TOutputParameters(line, pos); }
    Token new47(  String text,   int line,   int pos) { return new TInclusion(text, line, pos); }
    Token new48(  String text,   int line,   int pos) { return new TStrictInclusion(text, line, pos); }
    Token new49(  String text,   int line,   int pos) { return new TDomainSubtraction(text, line, pos); }
    Token new50(  String text,   int line,   int pos) { return new TLessEqual(text, line, pos); }
    Token new51(  String text,   int line,   int pos) { return new TEquivalence(text, line, pos); }
    Token new52(  String text,   int line,   int pos) { return new TDomainRestriction(text, line, pos); }
    Token new53(  int line,   int pos) { return new TEqual(line, pos); }
    Token new54(  int line,   int pos) { return new TDoubleEqual(line, pos); }
    Token new55(  String text,   int line,   int pos) { return new TImplies(text, line, pos); }
    Token new56(  int line,   int pos) { return new TGreater(line, pos); }
    Token new57(  String text,   int line,   int pos) { return new TPartialInjection(text, line, pos); }
    Token new58(  String text,   int line,   int pos) { return new TTotalInjection(text, line, pos); }
    Token new59(  int line,   int pos) { return new TPartialBijection(line, pos); }
    Token new60(  String text,   int line,   int pos) { return new TTotalBijection(text, line, pos); }
    Token new61(  String text,   int line,   int pos) { return new TDirectProduct(text, line, pos); }
    Token new62(  String text,   int line,   int pos) { return new TGreaterEqual(text, line, pos); }
    Token new63(  int line,   int pos) { return new TAbstractConstants(line, pos); }
    Token new64(  int line,   int pos) { return new TAbstractVariables(line, pos); }
    Token new65(  int line,   int pos) { return new TAny(line, pos); }
    Token new66(  int line,   int pos) { return new TAssert(line, pos); }
    Token new67(  int line,   int pos) { return new TAssertions(line, pos); }
    Token new68(  int line,   int pos) { return new TBe(line, pos); }
    Token new69(  int line,   int pos) { return new TBegin(line, pos); }
    Token new70(  int line,   int pos) { return new TBool(line, pos); }
    Token new71(  int line,   int pos) { return new TBfalse(line, pos); }
    Token new72(  int line,   int pos) { return new TCase(line, pos); }
    Token new73(  int line,   int pos) { return new TChoice(line, pos); }
    Token new74(  int line,   int pos) { return new TConcreteConstants(line, pos); }
    Token new75(  int line,   int pos) { return new TConcreteVariables(line, pos); }
    Token new76(  int line,   int pos) { return new TConstants(line, pos); }
    Token new77(  int line,   int pos) { return new TConstraints(line, pos); }
    Token new78(  int line,   int pos) { return new TDefinitions(line, pos); }
    Token new79(  int line,   int pos) { return new TDo(line, pos); }
    Token new80(  int line,   int pos) { return new TEither(line, pos); }
    Token new81(  int line,   int pos) { return new TElse(line, pos); }
    Token new82(  int line,   int pos) { return new TElsif(line, pos); }
    Token new83(  int line,   int pos) { return new TEnd(line, pos); }
    Token new84(  int line,   int pos) { return new TExtends(line, pos); }
    Token new85(  String text,   int line,   int pos) { return new TFalse(text, line, pos); }
    Token new86(  int line,   int pos) { return new TFin(line, pos); }
    Token new87(  int line,   int pos) { return new TFin1(line, pos); }
    Token new88(  int line,   int pos) { return new TIf(line, pos); }
    Token new89(  int line,   int pos) { return new TImplementation(line, pos); }
    Token new90(  int line,   int pos) { return new TImports(line, pos); }
    Token new91(  int line,   int pos) { return new TIn(line, pos); }
    Token new92(  int line,   int pos) { return new TIncludes(line, pos); }
    Token new93(  String text,   int line,   int pos) { return new TInitialisation(text, line, pos); }
    Token new94(  int line,   int pos) { return new TInt(line, pos); }
    Token new95(  String text,   int line,   int pos) { return new TInteger(text, line, pos); }
    Token new96(  String text,   int line,   int pos) { return new TQuantifiedInter(text, line, pos); }
    Token new97(  int line,   int pos) { return new TInvariant(line, pos); }
    Token new98(  int line,   int pos) { return new TLet(line, pos); }
    Token new99(  int line,   int pos) { return new TLocalOperations(line, pos); }
    Token new100(  int line,   int pos) { return new TMachine(line, pos); }
    Token new101(  int line,   int pos) { return new TModel(line, pos); }
    Token new102(  int line,   int pos) { return new TSystem(line, pos); }
    Token new103(  int line,   int pos) { return new TMaxInt(line, pos); }
    Token new104(  int line,   int pos) { return new TMinInt(line, pos); }
    Token new105(  String text,   int line,   int pos) { return new TNat(text, line, pos); }
    Token new106(  String text,   int line,   int pos) { return new TNat1(text, line, pos); }
    Token new107(  String text,   int line,   int pos) { return new TNatural(text, line, pos); }
    Token new108(  int line,   int pos) { return new TNatural1(line, pos); }
    Token new109(  int line,   int pos) { return new TOf(line, pos); }
    Token new110(  String text,   int line,   int pos) { return new TOperations(text, line, pos); }
    Token new111(  int line,   int pos) { return new TOr(line, pos); }
    Token new112(  int line,   int pos) { return new TPi(line, pos); }
    Token new113(  String text,   int line,   int pos) { return new TPow(text, line, pos); }
    Token new114(  String text,   int line,   int pos) { return new TPow1(text, line, pos); }
    Token new115(  int line,   int pos) { return new TPre(line, pos); }
    Token new116(  int line,   int pos) { return new TPromotes(line, pos); }
    Token new117(  int line,   int pos) { return new TProperties(line, pos); }
    Token new118(  int line,   int pos) { return new TRefines(line, pos); }
    Token new119(  int line,   int pos) { return new TRefinement(line, pos); }
    Token new120(  int line,   int pos) { return new TSees(line, pos); }
    Token new121(  int line,   int pos) { return new TSelect(line, pos); }
    Token new122(  int line,   int pos) { return new TSets(line, pos); }
    Token new123(  int line,   int pos) { return new TQuantifiedSet(line, pos); }
    Token new124(  int line,   int pos) { return new TSigma(line, pos); }
    Token new125(  int line,   int pos) { return new TString(line, pos); }
    Token new126(  int line,   int pos) { return new TThen(line, pos); }
    Token new127(  String text,   int line,   int pos) { return new TTrue(text, line, pos); }
    Token new128(  String text,   int line,   int pos) { return new TQuantifiedUnion(text, line, pos); }
    Token new129(  int line,   int pos) { return new TUses(line, pos); }
    Token new130(  int line,   int pos) { return new TValue(line, pos); }
    Token new131(  int line,   int pos) { return new TVar(line, pos); }
    Token new132(  int line,   int pos) { return new TVariant(line, pos); }
    Token new133(  int line,   int pos) { return new TVariables(line, pos); }
    Token new134(  int line,   int pos) { return new TWhen(line, pos); }
    Token new135(  int line,   int pos) { return new TWhere(line, pos); }
    Token new136(  int line,   int pos) { return new TWhile(line, pos); }
    Token new137(  String text,   int line,   int pos) { return new TEmptySequence(text, line, pos); }
    Token new138(  int line,   int pos) { return new TLeftBracket(line, pos); }
    Token new139(  int line,   int pos) { return new TRightBracket(line, pos); }
    Token new140(  String text,   int line,   int pos) { return new TUnion(text, line, pos); }
    Token new141(  int line,   int pos) { return new TRestrictTailSequence(line, pos); }
    Token new142(  int line,   int pos) { return new TConcatSequence(line, pos); }
    Token new143(  int line,   int pos) { return new TArity(line, pos); }
    Token new144(  int line,   int pos) { return new TBin(line, pos); }
    Token new145(  int line,   int pos) { return new TBoolCast(line, pos); }
    Token new146(  int line,   int pos) { return new TBtree(line, pos); }
    Token new147(  int line,   int pos) { return new TCard(line, pos); }
    Token new148(  int line,   int pos) { return new TClosure(line, pos); }
    Token new149(  int line,   int pos) { return new TClosure1(line, pos); }
    Token new150(  int line,   int pos) { return new TConc(line, pos); }
    Token new151(  int line,   int pos) { return new TConst(line, pos); }
    Token new152(  int line,   int pos) { return new TDom(line, pos); }
    Token new153(  int line,   int pos) { return new TFather(line, pos); }
    Token new154(  int line,   int pos) { return new TFirst(line, pos); }
    Token new155(  int line,   int pos) { return new TFnc(line, pos); }
    Token new156(  int line,   int pos) { return new TFront(line, pos); }
    Token new157(  int line,   int pos) { return new TId(line, pos); }
    Token new158(  int line,   int pos) { return new TInfix(line, pos); }
    Token new159(  int line,   int pos) { return new TGeneralizedInter(line, pos); }
    Token new160(  int line,   int pos) { return new TIseq(line, pos); }
    Token new161(  int line,   int pos) { return new TIseq1(line, pos); }
    Token new162(  int line,   int pos) { return new TIterate(line, pos); }
    Token new163(  int line,   int pos) { return new TLast(line, pos); }
    Token new164(  int line,   int pos) { return new TLeft(line, pos); }
    Token new165(  int line,   int pos) { return new TMax(line, pos); }
    Token new166(  int line,   int pos) { return new TMin(line, pos); }
    Token new167(  int line,   int pos) { return new TMirror(line, pos); }
    Token new168(  int line,   int pos) { return new TMod(line, pos); }
    Token new169(  String text,   int line,   int pos) { return new TNot(text, line, pos); }
    Token new170(  String text,   int line,   int pos) { return new TLogicalOr(text, line, pos); }
    Token new171(  int line,   int pos) { return new TPerm(line, pos); }
    Token new172(  int line,   int pos) { return new TPostfix(line, pos); }
    Token new173(  int line,   int pos) { return new TPred(line, pos); }
    Token new174(  int line,   int pos) { return new TPrefix(line, pos); }
    Token new175(  int line,   int pos) { return new TPrj1(line, pos); }
    Token new176(  int line,   int pos) { return new TPrj2(line, pos); }
    Token new177(  int line,   int pos) { return new TRank(line, pos); }
    Token new178(  int line,   int pos) { return new TRan(line, pos); }
    Token new179(  int line,   int pos) { return new TRec(line, pos); }
    Token new180(  int line,   int pos) { return new TRel(line, pos); }
    Token new181(  int line,   int pos) { return new TRev(line, pos); }
    Token new182(  int line,   int pos) { return new TRight(line, pos); }
    Token new183(  int line,   int pos) { return new TSeq(line, pos); }
    Token new184(  int line,   int pos) { return new TSeq1(line, pos); }
    Token new185(  int line,   int pos) { return new TSizet(line, pos); }
    Token new186(  int line,   int pos) { return new TSize(line, pos); }
    Token new187(  int line,   int pos) { return new TSkip(line, pos); }
    Token new188(  int line,   int pos) { return new TSons(line, pos); }
    Token new189(  int line,   int pos) { return new TSon(line, pos); }
    Token new190(  int line,   int pos) { return new TStruct(line, pos); }
    Token new191(  int line,   int pos) { return new TSubtree(line, pos); }
    Token new192(  int line,   int pos) { return new TSucc(line, pos); }
    Token new193(  int line,   int pos) { return new TTail(line, pos); }
    Token new194(  int line,   int pos) { return new TTop(line, pos); }
    Token new195(  int line,   int pos) { return new TTree(line, pos); }
    Token new196(  int line,   int pos) { return new TGeneralizedUnion(line, pos); }
    Token new197(  String text,   int line,   int pos) { return new TEmptySet(text, line, pos); }
    Token new198(  int line,   int pos) { return new TLeftBrace(line, pos); }
    Token new199(  int line,   int pos) { return new TRightBrace(line, pos); }
    Token new200(  int line,   int pos) { return new TVerticalBar(line, pos); }
    Token new201(  String text,   int line,   int pos) { return new TDoubleVerticalBar(text, line, pos); }
    Token new202(  String text,   int line,   int pos) { return new TMaplet(text, line, pos); }
    Token new203(  String text,   int line,   int pos) { return new TRangeRestriction(text, line, pos); }
    Token new204(  String text,   int line,   int pos) { return new TRangeSubtraction(text, line, pos); }
    Token new205(  String text,   int line,   int pos) { return new TTilde(text, line, pos); }
    Token new206(  String text,   int line,   int pos) { return new TTotalRelation(text, line, pos); }
    Token new207(  String text,   int line,   int pos) { return new TSurjectionRelation(text, line, pos); }
    Token new208(  String text,   int line,   int pos) { return new TTotalSurjectionRelation(text, line, pos); }
    Token new209(  int line,   int pos) { return new TKwExpression(line, pos); }
    Token new210(  int line,   int pos) { return new TKwPredicate(line, pos); }
    Token new211(  int line,   int pos) { return new TKwFormula(line, pos); }
    Token new212(  int line,   int pos) { return new TKwSubstitution(line, pos); }
    Token new213(  int line,   int pos) { return new TKwAbstractConstants(line, pos); }
    Token new214(  int line,   int pos) { return new TKwAbstractVariables(line, pos); }
    Token new215(  int line,   int pos) { return new TKwAssertions(line, pos); }
    Token new216(  int line,   int pos) { return new TKwConcreteConstants(line, pos); }
    Token new217(  int line,   int pos) { return new TKwConcreteVariables(line, pos); }
    Token new218(  int line,   int pos) { return new TKwConstants(line, pos); }
    Token new219(  int line,   int pos) { return new TKwConstraints(line, pos); }
    Token new220(  int line,   int pos) { return new TKwDefinitions(line, pos); }
    Token new221(  int line,   int pos) { return new TKwDefinition(line, pos); }
    Token new222(  int line,   int pos) { return new TKwExtends(line, pos); }
    Token new223(  int line,   int pos) { return new TKwImports(line, pos); }
    Token new224(  int line,   int pos) { return new TKwIncludes(line, pos); }
    Token new225(  int line,   int pos) { return new TKwInitialisation(line, pos); }
    Token new226(  int line,   int pos) { return new TKwInvariant(line, pos); }
    Token new227(  int line,   int pos) { return new TKwLocalOperations(line, pos); }
    Token new228(  int line,   int pos) { return new TKwOperations(line, pos); }
    Token new229(  int line,   int pos) { return new TKwPromotes(line, pos); }
    Token new230(  int line,   int pos) { return new TKwProperties(line, pos); }
    Token new231(  int line,   int pos) { return new TKwSees(line, pos); }
    Token new232(  int line,   int pos) { return new TKwSets(line, pos); }
    Token new233(  int line,   int pos) { return new TKwUses(line, pos); }
    Token new234(  int line,   int pos) { return new TKwVariables(line, pos); }
    Token new235(  int line,   int pos) { return new TKwValues(line, pos); }
    Token new236(  int line,   int pos) { return new TKwOppattern(line, pos); }
    Token new237(  String text,   int line,   int pos) { return new TIdentifierLiteral(text, line, pos); }
    Token new238(  String text,   int line,   int pos) { return new TDefLiteralSubstitution(text, line, pos); }
    Token new239(  String text,   int line,   int pos) { return new TDefLiteralPredicate(text, line, pos); }
    Token new240(  String text,   int line,   int pos) { return new TPredicateIdentifier(text, line, pos); }
    Token new241(  int line,   int pos) { return new TTruthPredicate(line, pos); }
    Token new242(  String text,   int line,   int pos) { return new TIntegerLiteral(text, line, pos); }
    Token new243(  String text,   int line,   int pos) { return new THexLiteral(text, line, pos); }
    Token new244(  String text,   int line,   int pos) { return new TUnderscore(text, line, pos); }
    Token new245(  String text,   int line,   int pos) { return new TWhiteSpace(text, line, pos); }

    private int getChar() throws IOException
    {
        if(this.eof)
        {
            return -1;
        }

        int result = this.in.read();

        if(result == -1)
        {
            this.eof = true;
        }

        return result;
    }

    private void pushBack(int acceptLength) throws IOException
    {
        int length = this.text.length();
        for(int i = length - 1; i >= acceptLength; i--)
        {
            this.eof = false;

            this.in.unread(this.text.charAt(i));
        }
    }

    protected void unread(  Token token) throws IOException
    {
          String text = token.getText();
        int length = text.length();

        for(int i = length - 1; i >= 0; i--)
        {
            this.eof = false;

            this.in.unread(text.charAt(i));
        }

        this.pos = token.getPos() - 1;
        this.line = token.getLine() - 1;
    }

    private String getText(int acceptLength)
    {
        StringBuffer s = new StringBuffer(acceptLength);
        for(int i = 0; i < acceptLength; i++)
        {
            s.append(this.text.charAt(i));
        }

        return s.toString();
    }

    private static int[][][][] gotoTable;
/*  {
        { // NORMAL
            {{0, 9, 1}, {10, 10, 2}, {11, 12, 1}, {13, 13, 2}, {14, 32, 1}, {33, 33, 3}, {34, 34, 4}, {35, 35, 5}, {36, 36, 6}, {37, 37, 7}, {38, 38, 8}, {39, 39, 9}, {40, 40, 10}, {41, 41, 11}, {42, 42, 12}, {43, 43, 13}, {44, 44, 14}, {45, 45, 15}, {46, 46, 16}, {47, 47, 17}, {48, 48, 18}, {49, 57, 19}, {58, 58, 20}, {59, 59, 21}, {60, 60, 22}, {61, 61, 23}, {62, 62, 24}, {65, 65, 25}, {66, 66, 26}, {67, 67, 27}, {68, 68, 28}, {69, 69, 29}, {70, 70, 30}, {71, 72, 31}, {73, 73, 32}, {74, 75, 31}, {76, 76, 33}, {77, 77, 34}, {78, 78, 35}, {79, 79, 36}, {80, 80, 37}, {81, 81, 31}, {82, 82, 38}, {83, 83, 39}, {84, 84, 40}, {85, 85, 41}, {86, 86, 42}, {87, 87, 43}, {88, 90, 31}, {91, 91, 44}, {92, 92, 45}, {93, 93, 46}, {94, 94, 47}, {95, 95, 48}, {97, 97, 49}, {98, 98, 50}, {99, 99, 51}, {100, 100, 52}, {101, 101, 53}, {102, 102, 54}, {103, 104, 53}, {105, 105, 55}, {106, 107, 53}, {108, 108, 56}, {109, 109, 57}, {110, 110, 58}, {111, 111, 59}, {112, 112, 60}, {113, 113, 53}, {114, 114, 61}, {115, 115, 62}, {116, 116, 63}, {117, 117, 64}, {118, 122, 53}, {123, 123, 65}, {124, 124, 66}, {125, 125, 67}, {126, 126, 68}, {127, 160, 1}, {172, 172, 69}, {183, 183, 70}, {215, 215, 71}, {955, 955, 72}, {8206, 8207, 1}, {8229, 8229, 73}, {8232, 8233, 1}, {8469, 8469, 74}, {8473, 8473, 75}, {8484, 8484, 76}, {8594, 8594, 77}, {8596, 8596, 78}, {8608, 8608, 79}, {8611, 8611, 80}, {8614, 8614, 81}, {8658, 8658, 82}, {8660, 8660, 83}, {8696, 8696, 84}, {8704, 8704, 85}, {8707, 8707, 86}, {8709, 8709, 87}, {8712, 8712, 88}, {8713, 8713, 89}, {8722, 8722, 90}, {8741, 8741, 91}, {8743, 8743, 92}, {8744, 8744, 93}, {8745, 8745, 94}, {8746, 8746, 95}, {8764, 8764, 96}, {8800, 8800, 97}, {8804, 8804, 98}, {8805, 8805, 99}, {8834, 8834, 100}, {8836, 8836, 101}, {8838, 8838, 102}, {8840, 8840, 103}, {8855, 8855, 104}, {8868, 8868, 105}, {8869, 8869, 106}, {8898, 8898, 107}, {8899, 8899, 108}, {9655, 9655, 109}, {9665, 9665, 110}, {10496, 10496, 111}, {10516, 10516, 112}, {10518, 10518, 113}, {10852, 10852, 114}, {10853, 10853, 115}, {57600, 57600, 116}, {57601, 57601, 117}, {57602, 57602, 118}, {57603, 57603, 119}, },
            {{0, 9, 1}, {11, 12, 1}, {14, 32, 1}, {127, 160, 1}, {8206, 8207, 1}, {8232, 8233, 1}, },
            {},
            {},
            {{0, 33, 120}, {34, 34, 121}, {35, 65535, 120}, },
            {{33, 33, 122}, {65, 65, 123}, {67, 67, 124}, {68, 68, 125}, {69, 69, 126}, {70, 70, 127}, {73, 73, 128}, {76, 76, 129}, {79, 79, 130}, {80, 80, 131}, {83, 83, 132}, {85, 85, 133}, {86, 86, 134}, {108, 108, 135}, {112, 112, 136}, {116, 116, 137}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {{42, 42, 138}, },
            {{45, 45, 139}, },
            {},
            {{45, 45, 140}, {62, 62, 141}, },
            {{0, 9, 142}, {10, 10, 143}, {11, 12, 142}, {13, 13, 143}, {14, 32, 142}, {40, 40, 144}, {46, 46, 145}, {127, 160, 142}, {8206, 8207, 142}, {8232, 8233, 142}, },
            {{42, 42, 146}, {58, 58, 147}, {60, 60, 148}, {61, 61, 149}, {92, 92, 150}, {124, 124, 151}, },
            {{48, 57, 19}, {120, 120, 152}, },
            {{48, 57, 19}, },
            {{58, 58, 153}, {61, 61, 154}, },
            {},
            {{0, 9, 155}, {10, 10, 156}, {11, 12, 155}, {13, 13, 156}, {14, 32, 155}, {43, 43, 157}, {45, 45, 158}, {58, 58, 159}, {60, 60, 160}, {61, 61, 161}, {62, 62, 162}, {124, 124, 163}, {127, 160, 155}, {8206, 8207, 155}, {8232, 8233, 155}, },
            {{61, 61, 164}, {62, 62, 165}, },
            {{43, 43, 166}, {45, 45, 167}, {60, 60, 168}, {61, 61, 169}, },
            {{48, 57, 170}, {65, 65, 171}, {66, 66, 172}, {67, 77, 171}, {78, 78, 173}, {79, 82, 171}, {83, 83, 174}, {84, 90, 171}, {95, 95, 175}, {97, 122, 176}, },
            {{48, 57, 170}, {65, 68, 171}, {69, 69, 177}, {70, 78, 171}, {79, 79, 178}, {80, 90, 171}, {95, 122, -27}, },
            {{48, 57, 170}, {65, 65, 179}, {66, 71, 171}, {72, 72, 180}, {73, 78, 171}, {79, 79, 181}, {80, 122, -28}, },
            {{48, 68, -28}, {69, 69, 182}, {70, 78, 171}, {79, 79, 183}, {80, 122, -28}, },
            {{48, 57, 170}, {65, 72, 171}, {73, 73, 184}, {74, 75, 171}, {76, 76, 185}, {77, 77, 171}, {78, 78, 186}, {79, 85, 171}, {86, 86, 187}, {87, 87, 171}, {88, 88, 188}, {89, 90, 171}, {95, 122, -27}, },
            {{48, 57, 170}, {65, 65, 189}, {66, 72, 171}, {73, 73, 190}, {74, 90, 171}, {95, 122, -27}, },
            {{48, 57, 170}, {65, 90, 171}, {95, 122, -27}, },
            {{48, 57, 170}, {65, 69, 171}, {70, 70, 191}, {71, 76, 171}, {77, 77, 192}, {78, 78, 193}, {79, 90, 171}, {95, 122, -27}, },
            {{48, 68, -28}, {69, 69, 194}, {70, 78, 171}, {79, 79, 195}, {80, 122, -28}, },
            {{48, 57, 170}, {65, 65, 196}, {66, 72, 171}, {73, 73, 197}, {74, 78, 171}, {79, 79, 198}, {80, 122, -28}, },
            {{48, 57, 170}, {65, 65, 199}, {66, 90, 171}, {95, 122, -27}, },
            {{48, 69, -34}, {70, 70, 200}, {71, 79, 171}, {80, 80, 201}, {81, 81, 171}, {82, 82, 202}, {83, 90, 171}, {95, 122, -27}, },
            {{48, 72, -31}, {73, 73, 203}, {74, 78, 171}, {79, 79, 204}, {80, 81, 171}, {82, 82, 205}, {83, 122, -38}, },
            {{48, 68, -28}, {69, 69, 206}, {70, 90, 171}, {95, 122, -27}, },
            {{48, 68, -28}, {69, 69, 207}, {70, 72, 171}, {73, 73, 208}, {74, 83, 171}, {84, 84, 209}, {85, 88, 171}, {89, 89, 210}, {90, 90, 171}, {95, 122, -27}, },
            {{48, 57, 170}, {65, 71, 171}, {72, 72, 211}, {73, 81, 171}, {82, 82, 212}, {83, 122, -38}, },
            {{48, 57, 170}, {65, 77, 171}, {78, 78, 213}, {79, 82, 171}, {83, 83, 214}, {84, 122, -27}, },
            {{48, 57, 170}, {65, 65, 215}, {66, 122, -37}, },
            {{48, 71, -42}, {72, 72, 216}, {73, 90, 171}, {95, 122, -27}, },
            {{0, 9, 217}, {10, 10, 218}, {11, 12, 217}, {13, 13, 218}, {14, 32, 217}, {93, 93, 219}, {127, 160, 217}, {8206, 8207, 217}, {8232, 8233, 217}, },
            {{47, 47, 220}, {124, 124, 221}, },
            {},
            {},
            {},
            {{48, 95, -33}, {97, 113, 176}, {114, 114, 222}, {115, 122, 176}, },
            {{48, 95, -33}, {97, 101, 176}, {102, 102, 223}, {103, 104, 176}, {105, 105, 224}, {106, 110, 176}, {111, 111, 225}, {112, 115, 176}, {116, 116, 226}, {117, 122, 176}, },
            {{48, 95, -33}, {97, 97, 227}, {98, 107, 176}, {108, 108, 228}, {109, 110, 176}, {111, 111, 229}, {112, 122, 176}, },
            {{48, 95, -33}, {97, 110, 176}, {111, 111, 230}, {112, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 95, -33}, {97, 97, 231}, {98, 104, 176}, {105, 105, 232}, {106, 109, 176}, {110, 110, 233}, {111, 113, 176}, {114, 114, 234}, {115, 122, 176}, },
            {{48, 95, -33}, {97, 99, 176}, {100, 100, 235}, {101, 109, 176}, {110, 110, 236}, {111, 114, 176}, {115, 115, 237}, {116, 116, 238}, {117, 122, 176}, },
            {{48, 95, -33}, {97, 97, 239}, {98, 100, 176}, {101, 101, 240}, {102, 122, 176}, },
            {{48, 95, -33}, {97, 97, 241}, {98, 104, 176}, {105, 105, 242}, {106, 110, 176}, {111, 111, 243}, {112, 122, 176}, },
            {{48, 110, -54}, {111, 111, 244}, {112, 122, 176}, },
            {{48, 113, -51}, {114, 114, 245}, {115, 122, 176}, },
            {{48, 95, -33}, {97, 100, 176}, {101, 101, 246}, {102, 110, 176}, {111, 111, 247}, {112, 113, 176}, {114, 114, 248}, {115, 122, 176}, },
            {{48, 95, -33}, {97, 97, 249}, {98, 100, 176}, {101, 101, 250}, {102, 104, 176}, {105, 105, 251}, {106, 122, 176}, },
            {{48, 100, -62}, {101, 101, 252}, {102, 104, 176}, {105, 105, 253}, {106, 106, 176}, {107, 107, 254}, {108, 110, 176}, {111, 111, 255}, {112, 115, 176}, {116, 116, 256}, {117, 117, 257}, {118, 122, 176}, },
            {{48, 95, -33}, {97, 97, 258}, {98, 110, 176}, {111, 111, 259}, {112, 113, 176}, {114, 114, 260}, {115, 122, 176}, },
            {{48, 95, -33}, {97, 109, 176}, {110, 110, 261}, {111, 122, 176}, },
            {{0, 9, 262}, {10, 10, 263}, {11, 12, 262}, {13, 13, 263}, {14, 32, 262}, {125, 125, 264}, {127, 160, 262}, {8206, 8207, 262}, {8232, 8233, 262}, },
            {{45, 45, 265}, {62, 62, 266}, {124, 124, 267}, },
            {},
            {},
            {},
            {{0, 9, 268}, {10, 10, 269}, {11, 12, 268}, {13, 13, 269}, {14, 32, 268}, {40, 40, 270}, {127, 160, 268}, {8206, 8207, 268}, {8232, 8233, 268}, },
            {},
            {},
            {},
            {{49, 49, 271}, },
            {{49, 49, 272}, },
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {},
            {{0, 65535, -6}, },
            {},
            {},
            {{66, 66, 273}, {83, 83, 274}, },
            {{79, 79, 275}, },
            {{69, 69, 276}, },
            {{88, 88, 277}, },
            {{79, 79, 278}, },
            {{77, 77, 279}, {78, 78, 280}, },
            {{79, 79, 281}, },
            {{80, 80, 282}, },
            {{82, 82, 283}, },
            {{69, 69, 284}, {85, 85, 285}, },
            {{83, 83, 286}, },
            {{65, 65, 287}, },
            {{105, 105, 288}, },
            {{114, 114, 289}, },
            {{114, 114, 290}, },
            {},
            {{62, 62, 291}, },
            {{62, 62, 292}, },
            {},
            {{0, 40, -18}, {127, 8233, -18}, },
            {{0, 8233, -144}, },
            {},
            {},
            {},
            {},
            {{58, 58, 293}, {60, 60, 294}, },
            {},
            {},
            {{92, 92, 295}, },
            {{48, 57, 296}, {65, 70, 296}, {97, 102, 296}, },
            {},
            {},
            {{0, 32, -24}, {62, 62, 162}, {127, 8233, -24}, },
            {{0, 8233, -157}, },
            {},
            {{45, 45, 297}, {62, 62, 298}, },
            {},
            {{45, 45, 299}, {58, 58, 300}, {124, 124, 301}, },
            {{62, 62, 302}, },
            {},
            {},
            {},
            {},
            {{62, 62, 303}, },
            {{62, 62, 304}, },
            {},
            {},
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 57, 170}, {65, 82, 171}, {83, 83, 305}, {84, 122, -27}, },
            {{48, 57, 170}, {65, 88, 171}, {89, 89, 306}, {90, 122, -41}, },
            {{48, 82, -174}, {83, 83, 307}, {84, 122, -27}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 57, 170}, {65, 70, 171}, {71, 71, 308}, {72, 90, 171}, {95, 122, -27}, },
            {{48, 57, 170}, {65, 78, 171}, {79, 79, 309}, {80, 122, -28}, },
            {{48, 82, -174}, {83, 83, 310}, {84, 122, -27}, },
            {{48, 78, -180}, {79, 79, 311}, {80, 122, -28}, },
            {{48, 77, -43}, {78, 78, 312}, {79, 122, -34}, },
            {{48, 69, -34}, {70, 70, 313}, {71, 90, 171}, {95, 122, -27}, },
            {{48, 122, -33}, },
            {{48, 57, 170}, {65, 83, 171}, {84, 84, 314}, {85, 90, 171}, {95, 122, -27}, },
            {{48, 82, -174}, {83, 83, 315}, {84, 122, -27}, },
            {{48, 57, 170}, {65, 67, 171}, {68, 68, 316}, {69, 90, 171}, {95, 122, -27}, },
            {{48, 68, -28}, {69, 69, 317}, {70, 122, -40}, },
            {{48, 83, -186}, {84, 84, 318}, {85, 122, -186}, },
            {{48, 57, 170}, {65, 75, 171}, {76, 76, 319}, {77, 90, 171}, {95, 122, -27}, },
            {{48, 77, -43}, {78, 78, 320}, {79, 122, -34}, },
            {{48, 122, -33}, },
            {{48, 57, 170}, {65, 79, 171}, {80, 80, 321}, {81, 90, 171}, {95, 122, -27}, },
            {{48, 57, 170}, {65, 66, 171}, {67, 67, 322}, {68, 72, 171}, {73, 73, 323}, {74, 83, 171}, {84, 84, 324}, {85, 85, 171}, {86, 86, 325}, {87, 90, 171}, {95, 122, -27}, },
            {{48, 83, -186}, {84, 84, 326}, {85, 122, -186}, },
            {{48, 66, -195}, {67, 67, 327}, {68, 90, 171}, {95, 122, -27}, },
            {{48, 66, -195}, {67, 67, 328}, {68, 87, 171}, {88, 88, 329}, {89, 122, -31}, },
            {{48, 77, -43}, {78, 78, 330}, {79, 122, -34}, },
            {{48, 67, -188}, {68, 68, 331}, {69, 122, -188}, },
            {{48, 83, -186}, {84, 84, 332}, {85, 122, -186}, },
            {{48, 122, -33}, },
            {{48, 68, -28}, {69, 69, 333}, {70, 122, -40}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 57, 170}, {65, 86, 171}, {87, 87, 334}, {88, 90, 171}, {95, 122, -27}, },
            {{48, 68, -28}, {69, 69, 335}, {70, 78, 171}, {79, 79, 336}, {80, 122, -28}, },
            {{48, 69, -34}, {70, 70, 337}, {71, 122, -184}, },
            {{48, 68, -28}, {69, 69, 338}, {70, 75, 171}, {76, 76, 339}, {77, 83, 171}, {84, 84, 340}, {85, 122, -186}, },
            {{48, 70, -179}, {71, 71, 341}, {72, 122, -179}, },
            {{48, 57, 170}, {65, 81, 171}, {82, 82, 342}, {83, 122, -38}, },
            {{48, 82, -174}, {83, 83, 343}, {84, 122, -27}, },
            {{48, 68, -28}, {69, 69, 344}, {70, 122, -40}, },
            {{48, 57, 170}, {65, 84, 171}, {85, 85, 345}, {86, 90, 171}, {95, 122, -27}, },
            {{48, 72, -31}, {73, 73, 346}, {74, 122, -32}, },
            {{48, 68, -28}, {69, 69, 347}, {70, 122, -40}, },
            {{48, 75, -191}, {76, 76, 348}, {77, 81, 171}, {82, 82, 349}, {83, 122, -38}, },
            {{48, 68, -28}, {69, 69, 350}, {70, 72, 171}, {73, 73, 351}, {74, 122, -32}, },
            {{0, 8233, -46}, },
            {{0, 8233, -46}, },
            {},
            {},
            {{47, 47, 352}, },
            {{48, 95, -33}, {97, 104, 176}, {105, 105, 353}, {106, 122, 176}, },
            {{48, 95, -33}, {97, 97, 354}, {98, 122, 176}, },
            {{48, 109, -66}, {110, 110, 355}, {111, 122, 176}, },
            {{48, 110, -54}, {111, 111, 356}, {112, 122, 176}, },
            {{48, 113, -51}, {114, 114, 357}, {115, 122, 176}, },
            {{48, 113, -51}, {114, 114, 358}, {115, 122, 176}, },
            {{48, 110, -54}, {111, 111, 359}, {112, 122, 176}, },
            {{48, 109, -66}, {110, 110, 360}, {111, 122, 176}, },
            {{48, 95, -33}, {97, 108, 176}, {109, 109, 361}, {110, 122, 176}, },
            {{48, 95, -33}, {97, 115, 176}, {116, 116, 362}, {117, 122, 176}, },
            {{48, 113, -51}, {114, 114, 363}, {115, 122, 176}, },
            {{48, 95, -33}, {97, 98, 176}, {99, 99, 364}, {100, 122, 176}, },
            {{48, 110, -54}, {111, 111, 365}, {112, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 101, -52}, {102, 102, 366}, {103, 115, 176}, {116, 116, 367}, {117, 122, 176}, },
            {{48, 100, -62}, {101, 101, 368}, {102, 122, 176}, },
            {{48, 100, -62}, {101, 101, 369}, {102, 122, 176}, },
            {{48, 95, -33}, {97, 114, 176}, {115, 115, 370}, {116, 122, 176}, },
            {{48, 101, -52}, {102, 102, 371}, {103, 122, 176}, },
            {{48, 95, -33}, {97, 119, 176}, {120, 120, 372}, {121, 122, 176}, },
            {{48, 109, -66}, {110, 110, 373}, {111, 113, 176}, {114, 114, 374}, {115, 122, 176}, },
            {{48, 99, -57}, {100, 100, 375}, {101, 122, 176}, },
            {{48, 115, -233}, {116, 116, 376}, {117, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 113, -51}, {114, 114, 377}, {115, 122, 176}, },
            {{48, 114, -241}, {115, 115, 378}, {116, 122, 176}, },
            {{48, 100, -62}, {101, 101, 379}, {102, 105, 176}, {106, 106, 380}, {107, 122, 176}, },
            {{48, 109, -66}, {110, 110, 381}, {111, 122, 176}, },
            {{48, 98, -235}, {99, 99, 382}, {100, 107, 176}, {108, 108, 383}, {109, 117, 176}, {118, 118, 384}, {119, 122, 176}, },
            {{48, 95, -33}, {97, 102, 176}, {103, 103, 385}, {104, 122, 176}, },
            {{48, 95, -33}, {97, 112, 176}, {113, 113, 386}, {114, 122, 176}, },
            {{48, 95, -33}, {97, 121, 176}, {122, 122, 387}, },
            {{48, 104, -224}, {105, 105, 388}, {106, 122, 176}, },
            {{48, 109, -66}, {110, 110, 389}, {111, 122, 176}, },
            {{48, 113, -51}, {114, 114, 390}, {115, 122, 176}, },
            {{48, 95, -33}, {97, 97, 176}, {98, 98, 391}, {99, 99, 392}, {100, 122, 176}, },
            {{48, 104, -224}, {105, 105, 393}, {106, 122, 176}, },
            {{48, 95, -33}, {97, 111, 176}, {112, 112, 394}, {113, 122, 176}, },
            {{48, 100, -62}, {101, 101, 395}, {102, 122, 176}, },
            {{48, 104, -224}, {105, 105, 396}, {106, 122, 176}, },
            {{0, 8233, -67}, },
            {{0, 8233, -67}, },
            {},
            {{62, 62, 397}, },
            {{62, 62, 398}, },
            {},
            {{0, 8233, -72}, },
            {{0, 8233, -72}, },
            {},
            {},
            {},
            {{83, 83, 399}, },
            {{83, 83, 400}, },
            {{78, 78, 401}, },
            {{70, 70, 402}, },
            {{80, 80, 403}, {84, 84, 404}, },
            {{82, 82, 405}, },
            {{80, 80, 406}, },
            {{67, 67, 407}, {73, 73, 408}, {86, 86, 409}, },
            {{67, 67, 410}, },
            {{69, 69, 411}, {80, 80, 412}, },
            {{69, 69, 413}, {79, 79, 414}, },
            {{69, 69, 415}, {84, 84, 416}, },
            {{66, 66, 417}, },
            {{69, 69, 418}, },
            {{76, 76, 419}, {82, 82, 420}, },
            {{116, 116, 421}, },
            {{101, 101, 422}, },
            {{117, 117, 423}, },
            {{62, 62, 424}, },
            {{62, 62, 425}, },
            {},
            {{58, 58, 426}, },
            {},
            {{48, 102, -154}, },
            {},
            {{62, 62, 427}, },
            {{62, 62, 428}, },
            {},
            {},
            {},
            {{62, 62, 429}, },
            {{62, 62, 430}, },
            {{48, 83, -186}, {84, 84, 431}, {85, 122, -186}, },
            {{48, 122, -33}, },
            {{48, 68, -28}, {69, 69, 432}, {70, 122, -40}, },
            {{48, 72, -31}, {73, 73, 433}, {74, 122, -32}, },
            {{48, 75, -191}, {76, 76, 434}, {77, 122, -191}, },
            {{48, 68, -28}, {69, 69, 435}, {70, 122, -40}, },
            {{48, 72, -31}, {73, 73, 436}, {74, 122, -32}, },
            {{48, 66, -195}, {67, 67, 437}, {68, 82, 171}, {83, 83, 438}, {84, 122, -27}, },
            {{48, 72, -31}, {73, 73, 439}, {74, 122, -32}, },
            {{48, 71, -42}, {72, 72, 440}, {73, 122, -45}, },
            {{48, 68, -28}, {69, 69, 441}, {70, 72, 171}, {73, 73, 442}, {74, 122, -32}, },
            {{48, 122, -33}, },
            {{48, 77, -43}, {78, 78, 443}, {79, 122, -34}, },
            {{48, 68, -28}, {69, 69, 444}, {70, 122, -40}, },
            {{48, 82, -174}, {83, 83, 445}, {84, 122, -27}, },
            {{48, 48, 170}, {49, 49, 446}, {50, 57, 170}, {65, 122, -33}, },
            {{48, 75, -191}, {76, 76, 447}, {77, 78, 171}, {79, 79, 448}, {80, 122, -28}, },
            {{48, 75, -191}, {76, 76, 449}, {77, 122, -191}, },
            {{48, 83, -186}, {84, 84, 450}, {85, 122, -186}, },
            {{48, 68, -28}, {69, 69, 451}, {70, 122, -40}, },
            {{48, 57, 170}, {65, 65, 452}, {66, 122, -37}, },
            {{48, 122, -33}, },
            {{48, 57, 170}, {65, 65, 453}, {66, 122, -37}, },
            {{48, 71, -42}, {72, 72, 454}, {73, 122, -45}, },
            {{48, 72, -31}, {73, 73, 455}, {74, 122, -32}, },
            {{48, 72, -31}, {73, 73, 456}, {74, 122, -32}, },
            {{48, 68, -28}, {69, 69, 457}, {70, 122, -40}, },
            {{48, 48, 170}, {49, 49, 458}, {50, 57, 170}, {65, 84, 171}, {85, 85, 459}, {86, 122, -214}, },
            {{48, 81, -211}, {82, 82, 460}, {83, 122, -38}, },
            {{48, 48, 170}, {49, 49, 461}, {50, 122, -322}, },
            {{48, 122, -33}, },
            {{48, 57, 170}, {65, 76, 171}, {77, 77, 462}, {78, 79, 171}, {80, 80, 463}, {81, 122, -194}, },
            {{48, 72, -31}, {73, 73, 464}, {74, 122, -32}, },
            {{48, 82, -174}, {83, 83, 465}, {84, 122, -27}, },
            {{48, 68, -28}, {69, 69, 466}, {70, 122, -40}, },
            {{48, 82, -174}, {83, 83, 467}, {84, 122, -27}, },
            {{48, 76, -338}, {77, 77, 468}, {78, 90, 171}, {95, 122, -27}, },
            {{48, 72, -31}, {73, 73, 469}, {74, 122, -32}, },
            {{48, 83, -186}, {84, 84, 470}, {85, 122, -186}, },
            {{48, 77, -43}, {78, 78, 471}, {79, 122, -34}, },
            {{48, 68, -28}, {69, 69, 472}, {70, 122, -40}, },
            {{48, 78, -180}, {79, 79, 473}, {80, 122, -28}, },
            {{48, 82, -174}, {83, 83, 474}, {84, 122, -27}, },
            {{48, 84, -214}, {85, 85, 475}, {86, 122, -214}, },
            {{48, 72, -31}, {73, 73, 476}, {74, 122, -32}, },
            {{48, 77, -43}, {78, 78, 477}, {79, 81, 171}, {82, 82, 478}, {83, 122, -38}, },
            {{48, 75, -191}, {76, 76, 479}, {77, 122, -191}, },
            {},
            {{48, 115, -233}, {116, 116, 480}, {117, 122, 176}, },
            {{48, 95, -33}, {97, 107, 176}, {108, 108, 481}, {109, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 107, -356}, {108, 108, 482}, {109, 122, 176}, },
            {{48, 100, -62}, {101, 101, 483}, {102, 122, 176}, },
            {{48, 99, -57}, {100, 100, 484}, {101, 122, 176}, },
            {{48, 114, -241}, {115, 115, 485}, {116, 122, 176}, },
            {{48, 98, -235}, {99, 99, 486}, {100, 114, 176}, {115, 115, 487}, {116, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 95, -33}, {97, 103, 176}, {104, 104, 488}, {105, 122, 176}, },
            {{48, 114, -241}, {115, 115, 489}, {116, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 109, -66}, {110, 110, 490}, {111, 122, 176}, },
            {{48, 104, -224}, {105, 105, 491}, {106, 122, 176}, },
            {{48, 100, -62}, {101, 101, 492}, {102, 122, 176}, },
            {{48, 112, -254}, {113, 113, 493}, {114, 122, 176}, },
            {{48, 113, -51}, {114, 114, 494}, {115, 122, 176}, },
            {{48, 115, -233}, {116, 116, 495}, {117, 122, 176}, },
            {{48, 115, -233}, {116, 116, 496}, {117, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 113, -51}, {114, 114, 497}, {115, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 108, -232}, {109, 109, 498}, {110, 122, 176}, },
            {{48, 115, -233}, {116, 116, 499}, {117, 122, 176}, },
            {{48, 99, -57}, {100, 100, 500}, {101, 101, 176}, {102, 102, 501}, {103, 122, 176}, },
            {{48, 48, 170}, {49, 49, 502}, {50, 50, 503}, {51, 57, 170}, {65, 122, -33}, },
            {{48, 95, -33}, {97, 106, 176}, {107, 107, 504}, {108, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 103, -364}, {104, 104, 505}, {105, 122, 176}, },
            {{48, 48, 170}, {49, 49, 506}, {50, 122, -322}, },
            {{48, 100, -62}, {101, 101, 507}, {102, 122, 176}, },
            {{48, 111, -261}, {112, 112, 508}, {113, 122, 176}, },
            {{48, 114, -241}, {115, 115, 509}, {116, 122, 176}, },
            {{48, 95, -33}, {97, 116, 176}, {117, 117, 510}, {118, 122, 176}, },
            {{48, 115, -233}, {116, 116, 511}, {117, 122, 176}, },
            {{48, 98, -235}, {99, 99, 512}, {100, 122, 176}, },
            {{48, 107, -356}, {108, 108, 513}, {109, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 100, -62}, {101, 101, 514}, {102, 122, 176}, },
            {{48, 110, -54}, {111, 111, 515}, {112, 122, 176}, },
            {},
            {},
            {{84, 84, 516}, },
            {{69, 69, 517}, },
            {{67, 67, 518}, {83, 83, 519}, },
            {{73, 73, 520}, },
            {{82, 82, 521}, },
            {{69, 69, 522}, },
            {{77, 77, 523}, },
            {{79, 79, 524}, },
            {{76, 76, 525}, },
            {{84, 84, 526}, },
            {{65, 65, 527}, },
            {{65, 65, 528}, },
            {{82, 82, 529}, },
            {{65, 65, 530}, },
            {{68, 68, 531}, },
            {{77, 77, 532}, {80, 80, 533}, },
            {{83, 83, 534}, },
            {{83, 83, 535}, },
            {{83, 83, 536}, },
            {{83, 83, 537}, },
            {{85, 85, 538}, },
            {{73, 73, 539}, },
            {{101, 101, 540}, },
            {{100, 100, 541}, },
            {{116, 116, 542}, },
            {},
            {},
            {},
            {},
            {{62, 62, 543}, },
            {},
            {},
            {{48, 81, -211}, {82, 82, 544}, {83, 122, -38}, },
            {{48, 81, -211}, {82, 82, 545}, {83, 122, -38}, },
            {{48, 77, -43}, {78, 78, 546}, {79, 122, -34}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 66, -195}, {67, 67, 547}, {68, 122, -197}, },
            {{48, 81, -211}, {82, 82, 548}, {83, 122, -38}, },
            {{48, 83, -186}, {84, 84, 549}, {85, 122, -186}, },
            {{48, 77, -43}, {78, 78, 550}, {79, 122, -34}, },
            {{48, 68, -28}, {69, 69, 551}, {70, 122, -40}, },
            {{48, 122, -33}, },
            {{48, 69, -34}, {70, 70, 552}, {71, 122, -184}, },
            {{48, 83, -186}, {84, 84, 553}, {85, 122, -186}, },
            {{48, 77, -43}, {78, 78, 554}, {79, 122, -34}, },
            {{48, 68, -28}, {69, 69, 555}, {70, 122, -40}, },
            {{48, 122, -33}, },
            {{48, 68, -28}, {69, 69, 556}, {70, 122, -40}, },
            {{48, 81, -211}, {82, 82, 557}, {83, 122, -38}, },
            {{48, 84, -214}, {85, 85, 558}, {86, 122, -214}, },
            {{48, 72, -31}, {73, 73, 559}, {74, 122, -32}, },
            {{48, 70, -179}, {71, 71, 560}, {72, 81, 171}, {82, 82, 561}, {83, 122, -38}, },
            {{48, 81, -211}, {82, 82, 562}, {83, 122, -38}, },
            {{48, 75, -191}, {76, 76, 563}, {77, 122, -191}, },
            {{48, 72, -31}, {73, 73, 564}, {74, 122, -32}, },
            {{48, 77, -43}, {78, 78, 565}, {79, 122, -34}, },
            {{48, 77, -43}, {78, 78, 566}, {79, 122, -34}, },
            {{48, 75, -191}, {76, 76, 567}, {77, 122, -191}, },
            {{48, 122, -33}, },
            {{48, 81, -211}, {82, 82, 568}, {83, 122, -38}, },
            {{48, 57, 170}, {65, 65, 569}, {66, 122, -37}, },
            {{48, 122, -33}, },
            {{48, 78, -180}, {79, 79, 570}, {80, 122, -28}, },
            {{48, 68, -28}, {69, 69, 571}, {70, 122, -40}, },
            {{48, 77, -43}, {78, 78, 572}, {79, 122, -34}, },
            {{48, 122, -33}, },
            {{48, 66, -195}, {67, 67, 573}, {68, 122, -197}, },
            {{48, 122, -33}, },
            {{48, 57, 170}, {65, 65, 574}, {66, 122, -37}, },
            {{48, 77, -43}, {78, 78, 575}, {79, 122, -34}, },
            {{48, 68, -28}, {69, 69, 576}, {70, 122, -40}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 77, -43}, {78, 78, 577}, {79, 122, -34}, },
            {{48, 122, -33}, },
            {{48, 68, -28}, {69, 69, 578}, {70, 122, -40}, },
            {{48, 57, 170}, {65, 65, 579}, {66, 122, -37}, },
            {{48, 122, -33}, },
            {{48, 68, -28}, {69, 69, 580}, {70, 122, -40}, },
            {{48, 68, -28}, {69, 69, 581}, {70, 122, -40}, },
            {{48, 95, -33}, {97, 120, 176}, {121, 121, 582}, {122, 122, 176}, },
            {{48, 114, -241}, {115, 115, 583}, {116, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 100, -62}, {101, 101, 584}, {102, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 116, -392}, {117, 117, 585}, {118, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 115, -233}, {116, 116, 586}, {117, 122, 176}, },
            {{48, 100, -62}, {101, 101, 587}, {102, 122, 176}, },
            {{48, 115, -233}, {116, 116, 588}, {117, 122, 176}, },
            {{48, 115, -233}, {116, 116, 589}, {117, 122, 176}, },
            {{48, 119, -243}, {120, 120, 590}, {121, 122, 176}, },
            {{48, 113, -51}, {114, 114, 591}, {115, 122, 176}, },
            {{48, 48, 170}, {49, 49, 592}, {50, 122, -322}, },
            {{48, 95, -33}, {97, 97, 593}, {98, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 110, -54}, {111, 111, 594}, {112, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 101, -52}, {102, 102, 595}, {103, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 104, -224}, {105, 105, 596}, {106, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 115, -233}, {116, 116, 597}, {117, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 115, -233}, {116, 116, 598}, {117, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 98, -235}, {99, 99, 599}, {100, 122, 176}, },
            {{48, 113, -51}, {114, 114, 600}, {115, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 109, -66}, {110, 110, 601}, {111, 122, 176}, },
            {{82, 82, 602}, },
            {{82, 82, 603}, },
            {{82, 82, 604}, },
            {{84, 84, 605}, },
            {{78, 78, 606}, },
            {{69, 69, 607}, },
            {{78, 78, 608}, },
            {{85, 85, 609}, },
            {{82, 82, 610}, },
            {{85, 85, 611}, },
            {{73, 73, 612}, },
            {{82, 82, 613}, },
            {{76, 76, 614}, },
            {{65, 65, 615}, },
            {{84, 84, 616}, },
            {{73, 73, 617}, },
            {{79, 79, 618}, },
            {{69, 69, 619}, },
            {},
            {},
            {{84, 84, 620}, },
            {},
            {{69, 69, 621}, },
            {{65, 65, 622}, },
            {{114, 114, 623}, },
            {{105, 105, 624}, },
            {{104, 104, 625}, },
            {},
            {{48, 57, 170}, {65, 65, 626}, {66, 122, -37}, },
            {{48, 83, -186}, {84, 84, 627}, {85, 122, -186}, },
            {{48, 122, -33}, },
            {{48, 68, -28}, {69, 69, 628}, {70, 122, -40}, },
            {{48, 68, -28}, {69, 69, 629}, {70, 122, -40}, },
            {{48, 57, 170}, {65, 65, 630}, {66, 81, 171}, {82, 82, 631}, {83, 122, -38}, },
            {{48, 72, -31}, {73, 73, 632}, {74, 122, -32}, },
            {{48, 81, -211}, {82, 82, 633}, {83, 122, -38}, },
            {{48, 122, -33}, },
            {{48, 82, -174}, {83, 83, 634}, {84, 122, -27}, },
            {{48, 67, -188}, {68, 68, 635}, {69, 122, -188}, },
            {{48, 122, -33}, },
            {{48, 76, -338}, {77, 77, 636}, {78, 122, -343}, },
            {{48, 83, -186}, {84, 84, 637}, {85, 122, -186}, },
            {{48, 67, -188}, {68, 68, 638}, {69, 122, -188}, },
            {{48, 57, 170}, {65, 65, 639}, {66, 122, -37}, },
            {{48, 68, -28}, {69, 69, 640}, {70, 122, -40}, },
            {{48, 122, -33}, },
            {{48, 72, -31}, {73, 73, 641}, {74, 122, -32}, },
            {{48, 90, -33}, {95, 95, 642}, {97, 122, 176}, },
            {{48, 77, -43}, {78, 78, 643}, {79, 122, -34}, },
            {{48, 83, -186}, {84, 84, 644}, {85, 122, -186}, },
            {{48, 83, -186}, {84, 84, 645}, {85, 122, -186}, },
            {{48, 122, -33}, },
            {{48, 57, 170}, {65, 65, 646}, {66, 122, -37}, },
            {{48, 83, -186}, {84, 84, 647}, {85, 122, -186}, },
            {{48, 83, -186}, {84, 84, 648}, {85, 122, -186}, },
            {{48, 81, -211}, {82, 82, 649}, {83, 122, -38}, },
            {{48, 68, -28}, {69, 69, 650}, {70, 122, -40}, },
            {{48, 83, -186}, {84, 84, 651}, {85, 122, -186}, },
            {{48, 122, -33}, },
            {{48, 70, -179}, {71, 71, 652}, {72, 122, -179}, },
            {{48, 76, -338}, {77, 77, 653}, {78, 122, -343}, },
            {{48, 122, -33}, },
            {{48, 82, -174}, {83, 83, 654}, {84, 122, -27}, },
            {{48, 65, -27}, {66, 66, 655}, {67, 77, 171}, {78, 78, 656}, {79, 122, -34}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 100, -62}, {101, 101, 657}, {102, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 113, -51}, {114, 114, 658}, {115, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 113, -51}, {114, 114, 659}, {115, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 115, -233}, {116, 116, 660}, {117, 122, 176}, },
            {{48, 113, -51}, {114, 114, 661}, {115, 122, 176}, },
            {{48, 104, -224}, {105, 105, 662}, {106, 122, 176}, },
            {{48, 119, -243}, {120, 120, 663}, {121, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 115, -233}, {116, 116, 664}, {117, 122, 176}, },
            {{48, 100, -62}, {101, 101, 665}, {102, 122, 176}, },
            {{48, 122, -33}, },
            {{65, 65, 666}, },
            {{84, 84, 667}, },
            {{69, 69, 668}, },
            {{65, 65, 669}, {82, 82, 670}, },
            {{73, 73, 671}, },
            {{83, 83, 672}, },
            {{68, 68, 673}, },
            {{76, 76, 674}, },
            {{84, 84, 675}, },
            {{68, 68, 676}, },
            {{65, 65, 677}, },
            {{73, 73, 678}, },
            {{95, 95, 679}, },
            {{84, 84, 680}, },
            {{84, 84, 681}, },
            {{67, 67, 682}, },
            {{84, 84, 683}, },
            {{82, 82, 684}, },
            {{73, 73, 685}, },
            {{83, 83, 686}, },
            {{66, 66, 687}, },
            {{97, 97, 688}, },
            {{99, 99, 689}, },
            {{95, 95, 690}, },
            {{48, 66, -195}, {67, 67, 691}, {68, 122, -197}, },
            {{48, 72, -31}, {73, 73, 692}, {74, 122, -32}, },
            {{48, 122, -33}, },
            {{48, 83, -186}, {84, 84, 693}, {85, 122, -186}, },
            {{48, 77, -43}, {78, 78, 694}, {79, 122, -34}, },
            {{48, 57, 170}, {65, 65, 695}, {66, 122, -37}, },
            {{48, 83, -186}, {84, 84, 696}, {85, 122, -186}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 82, -174}, {83, 83, 697}, {84, 122, -27}, },
            {{48, 68, -28}, {69, 69, 698}, {70, 122, -40}, },
            {{48, 82, -174}, {83, 83, 699}, {84, 122, -27}, },
            {{48, 68, -28}, {69, 69, 700}, {70, 122, -40}, },
            {{48, 75, -191}, {76, 76, 701}, {77, 122, -191}, },
            {{48, 81, -211}, {82, 82, 702}, {83, 122, -38}, },
            {{48, 57, 170}, {65, 65, 703}, {66, 122, -37}, },
            {{48, 78, -180}, {79, 79, 704}, {80, 122, -28}, },
            {{48, 68, -28}, {69, 69, 705}, {70, 122, -40}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 75, -191}, {76, 76, 706}, {77, 122, -191}, },
            {{48, 72, -31}, {73, 73, 707}, {74, 122, -32}, },
            {{48, 68, -28}, {69, 69, 708}, {70, 122, -40}, },
            {{48, 83, -186}, {84, 84, 709}, {85, 122, -186}, },
            {{48, 76, -338}, {77, 77, 710}, {78, 82, 171}, {83, 83, 711}, {84, 122, -27}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 75, -191}, {76, 76, 712}, {77, 122, -191}, },
            {{48, 83, -186}, {84, 84, 713}, {85, 122, -186}, },
            {{48, 122, -33}, },
            {{48, 100, -62}, {101, 101, 714}, {102, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 100, -62}, {101, 101, 715}, {102, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 119, -243}, {120, 120, 716}, {121, 122, 176}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 100, -62}, {101, 101, 717}, {102, 122, 176}, },
            {{67, 67, 718}, },
            {{73, 73, 719}, },
            {{84, 84, 720}, },
            {{78, 78, 721}, },
            {{65, 65, 722}, },
            {{84, 84, 723}, },
            {{83, 83, 724}, },
            {{83, 83, 725}, },
            {{65, 65, 726}, },
            {{83, 83, 727}, },
            {{69, 69, 728}, },
            {{76, 76, 729}, },
            {{65, 65, 730}, },
            {{79, 79, 731}, },
            {{73, 73, 732}, },
            {{69, 69, 733}, },
            {{65, 65, 734}, },
            {{69, 69, 735}, },
            {{84, 84, 736}, },
            {{84, 84, 737}, },
            {},
            {{76, 76, 738}, },
            {{108, 108, 739}, },
            {{97, 97, 740}, },
            {{112, 112, 741}, },
            {{48, 83, -186}, {84, 84, 742}, {85, 122, -186}, },
            {{48, 78, -180}, {79, 79, 743}, {80, 122, -28}, },
            {{48, 68, -28}, {69, 69, 744}, {70, 122, -40}, },
            {{48, 83, -186}, {84, 84, 745}, {85, 122, -186}, },
            {{48, 72, -31}, {73, 73, 746}, {74, 122, -32}, },
            {{48, 72, -31}, {73, 73, 747}, {74, 122, -32}, },
            {{48, 122, -33}, },
            {{48, 77, -43}, {78, 78, 748}, {79, 122, -34}, },
            {{48, 122, -33}, },
            {{48, 82, -174}, {83, 83, 749}, {84, 122, -27}, },
            {{48, 72, -31}, {73, 73, 750}, {74, 122, -32}, },
            {{48, 122, -33}, },
            {{48, 77, -43}, {78, 78, 751}, {79, 122, -34}, },
            {{48, 79, -194}, {80, 80, 752}, {81, 122, -194}, },
            {{48, 122, -33}, },
            {{48, 48, 170}, {49, 49, 753}, {50, 122, -322}, },
            {{48, 78, -180}, {79, 79, 754}, {80, 122, -28}, },
            {{48, 82, -174}, {83, 83, 755}, {84, 122, -27}, },
            {{48, 72, -31}, {73, 73, 756}, {74, 122, -32}, },
            {{48, 68, -28}, {69, 69, 757}, {70, 122, -40}, },
            {{48, 122, -33}, },
            {{48, 68, -28}, {69, 69, 758}, {70, 122, -40}, },
            {{48, 122, -33}, },
            {{48, 48, 170}, {49, 49, 759}, {50, 122, -322}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{84, 84, 760}, },
            {{79, 79, 761}, },
            {{69, 69, 762}, },
            {{84, 84, 763}, },
            {{73, 73, 764}, },
            {{73, 73, 765}, },
            {{73, 73, 766}, },
            {},
            {},
            {},
            {{83, 83, 767}, },
            {{73, 73, 768}, },
            {{78, 78, 769}, },
            {{80, 80, 770}, },
            {{79, 79, 771}, },
            {{82, 82, 772}, },
            {{84, 84, 773}, },
            {{83, 83, 774}, },
            {{73, 73, 775}, },
            {{85, 85, 776}, },
            {{69, 69, 777}, },
            {{95, 95, 778}, },
            {{116, 116, 779}, },
            {{114, 114, 780}, },
            {{48, 90, -33}, {95, 95, 781}, {97, 122, 176}, },
            {{48, 77, -43}, {78, 78, 782}, {79, 122, -34}, },
            {{48, 90, -33}, {95, 95, 783}, {97, 122, 176}, },
            {{48, 82, -174}, {83, 83, 784}, {84, 122, -27}, },
            {{48, 77, -43}, {78, 78, 785}, {79, 122, -34}, },
            {{48, 78, -180}, {79, 79, 786}, {80, 122, -28}, },
            {{48, 83, -186}, {84, 84, 787}, {85, 122, -186}, },
            {{48, 122, -33}, },
            {{48, 82, -174}, {83, 83, 788}, {84, 89, 171}, {90, 90, 789}, {95, 122, -27}, },
            {{48, 83, -186}, {84, 84, 790}, {85, 122, -186}, },
            {{48, 68, -28}, {69, 69, 791}, {70, 122, -40}, },
            {{48, 122, -33}, },
            {{48, 77, -43}, {78, 78, 792}, {79, 122, -34}, },
            {{48, 122, -33}, },
            {{48, 68, -28}, {69, 69, 793}, {70, 122, -40}, },
            {{48, 77, -43}, {78, 78, 794}, {79, 122, -34}, },
            {{48, 82, -174}, {83, 83, 795}, {84, 122, -27}, },
            {{48, 122, -33}, },
            {{95, 95, 796}, },
            {{78, 78, 797}, },
            {{95, 95, 798}, },
            {{83, 83, 799}, },
            {{78, 78, 800}, },
            {{79, 79, 801}, },
            {{79, 79, 802}, },
            {},
            {{83, 83, 803}, },
            {{84, 84, 804}, },
            {{69, 69, 805}, },
            {{78, 78, 806}, },
            {{78, 78, 807}, },
            {{69, 69, 808}, },
            {},
            {{69, 69, 809}, },
            {{84, 84, 810}, },
            {{83, 83, 811}, },
            {{112, 112, 812}, {115, 115, 813}, },
            {{101, 101, 814}, },
            {{101, 101, 815}, },
            {{48, 66, -195}, {67, 67, 816}, {68, 85, 171}, {86, 86, 817}, {87, 122, -195}, },
            {{48, 82, -174}, {83, 83, 818}, {84, 122, -27}, },
            {{48, 66, -195}, {67, 67, 819}, {68, 85, 171}, {86, 86, 820}, {87, 122, -195}, },
            {{48, 122, -33}, },
            {{48, 83, -186}, {84, 84, 821}, {85, 122, -186}, },
            {{48, 77, -43}, {78, 78, 822}, {79, 122, -34}, },
            {{48, 57, 170}, {65, 65, 823}, {66, 122, -37}, },
            {{48, 57, 170}, {65, 65, 824}, {66, 122, -37}, },
            {{48, 57, 170}, {65, 65, 825}, {66, 122, -37}, },
            {{48, 122, -33}, },
            {{48, 81, -211}, {82, 82, 826}, {83, 122, -38}, },
            {{48, 82, -174}, {83, 83, 827}, {84, 122, -27}, },
            {{48, 82, -174}, {83, 83, 828}, {84, 122, -27}, },
            {{48, 83, -186}, {84, 84, 829}, {85, 122, -186}, },
            {{48, 122, -33}, },
            {{67, 67, 830}, {86, 86, 831}, },
            {{83, 83, 832}, },
            {{67, 67, 833}, {86, 86, 834}, },
            {},
            {{84, 84, 835}, },
            {{78, 78, 836}, },
            {{78, 78, 837}, },
            {{65, 65, 838}, },
            {},
            {{82, 82, 839}, },
            {{83, 83, 840}, },
            {},
            {},
            {{83, 83, 841}, },
            {{73, 73, 842}, },
            {},
            {{114, 114, 843}, },
            {{117, 117, 844}, },
            {{95, 95, 845}, },
            {{100, 100, 846}, },
            {{48, 78, -180}, {79, 79, 847}, {80, 122, -28}, },
            {{48, 57, 170}, {65, 65, 848}, {66, 122, -37}, },
            {{48, 122, -33}, },
            {{48, 78, -180}, {79, 79, 849}, {80, 122, -28}, },
            {{48, 57, 170}, {65, 65, 850}, {66, 122, -37}, },
            {{48, 82, -174}, {83, 83, 851}, {84, 122, -27}, },
            {{48, 82, -174}, {83, 83, 852}, {84, 122, -27}, },
            {{48, 83, -186}, {84, 84, 853}, {85, 122, -186}, },
            {{48, 83, -186}, {84, 84, 854}, {85, 122, -186}, },
            {{48, 83, -186}, {84, 84, 855}, {85, 122, -186}, },
            {{48, 57, 170}, {65, 65, 856}, {66, 122, -37}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{79, 79, 857}, },
            {{65, 65, 858}, },
            {},
            {{79, 79, 859}, },
            {{65, 65, 860}, },
            {{83, 83, 861}, },
            {{83, 83, 862}, },
            {},
            {{84, 84, 863}, },
            {{65, 65, 864}, },
            {},
            {},
            {{79, 79, 865}, },
            {{101, 101, 866}, },
            {{98, 98, 867}, },
            {{105, 105, 868}, },
            {{105, 105, 869}, },
            {{48, 77, -43}, {78, 78, 870}, {79, 122, -34}, },
            {{48, 81, -211}, {82, 82, 871}, {83, 122, -38}, },
            {{48, 77, -43}, {78, 78, 872}, {79, 122, -34}, },
            {{48, 81, -211}, {82, 82, 873}, {83, 122, -38}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 72, -31}, {73, 73, 874}, {74, 122, -32}, },
            {{48, 72, -31}, {73, 73, 875}, {74, 122, -32}, },
            {{48, 72, -31}, {73, 73, 876}, {74, 122, -32}, },
            {{48, 83, -186}, {84, 84, 877}, {85, 122, -186}, },
            {{78, 78, 878}, },
            {{82, 82, 879}, },
            {{78, 78, 880}, },
            {{82, 82, 881}, },
            {},
            {},
            {{73, 73, 882}, },
            {{84, 84, 883}, },
            {{78, 78, 884}, },
            {{100, 100, 885}, },
            {{115, 115, 886}, },
            {{100, 100, 887}, },
            {{99, 99, 888}, },
            {{48, 82, -174}, {83, 83, 889}, {84, 122, -27}, },
            {{48, 72, -31}, {73, 73, 890}, {74, 122, -32}, },
            {{48, 82, -174}, {83, 83, 891}, {84, 122, -27}, },
            {{48, 72, -31}, {73, 73, 892}, {74, 122, -32}, },
            {{48, 78, -180}, {79, 79, 893}, {80, 122, -28}, },
            {{48, 78, -180}, {79, 79, 894}, {80, 122, -28}, },
            {{48, 78, -180}, {79, 79, 895}, {80, 122, -28}, },
            {{48, 72, -31}, {73, 73, 896}, {74, 122, -32}, },
            {{83, 83, 897}, },
            {{73, 73, 898}, },
            {{83, 83, 899}, },
            {{73, 73, 900}, },
            {{79, 79, 901}, },
            {{73, 73, 902}, },
            {},
            {{105, 105, 903}, },
            {{116, 116, 904}, },
            {{101, 101, 905}, },
            {{97, 97, 906}, },
            {{48, 83, -186}, {84, 84, 907}, {85, 122, -186}, },
            {{48, 57, 170}, {65, 65, 908}, {66, 122, -37}, },
            {{48, 83, -186}, {84, 84, 909}, {85, 122, -186}, },
            {{48, 57, 170}, {65, 65, 910}, {66, 122, -37}, },
            {{48, 77, -43}, {78, 78, 911}, {79, 122, -34}, },
            {{48, 77, -43}, {78, 78, 912}, {79, 122, -34}, },
            {{48, 77, -43}, {78, 78, 913}, {79, 122, -34}, },
            {{48, 78, -180}, {79, 79, 914}, {80, 122, -28}, },
            {{84, 84, 915}, },
            {{65, 65, 916}, },
            {{84, 84, 917}, },
            {{65, 65, 918}, },
            {{78, 78, 919}, },
            {{79, 79, 920}, },
            {{99, 99, 921}, },
            {{105, 105, 922}, },
            {{110, 110, 923}, },
            {{116, 116, 924}, },
            {{48, 57, 170}, {65, 65, 925}, {66, 122, -37}, },
            {{48, 65, -27}, {66, 66, 926}, {67, 90, 171}, {95, 122, -27}, },
            {{48, 57, 170}, {65, 65, 927}, {66, 122, -37}, },
            {{48, 65, -27}, {66, 66, 928}, {67, 122, -910}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 77, -43}, {78, 78, 929}, {79, 122, -34}, },
            {{65, 65, 930}, },
            {{66, 66, 931}, },
            {{65, 65, 932}, },
            {{66, 66, 933}, },
            {},
            {{78, 78, 934}, },
            {{97, 97, 935}, },
            {{116, 116, 936}, },
            {{116, 116, 937}, },
            {{101, 101, 938}, },
            {{48, 77, -43}, {78, 78, 939}, {79, 122, -34}, },
            {{48, 75, -191}, {76, 76, 940}, {77, 122, -191}, },
            {{48, 77, -43}, {78, 78, 941}, {79, 122, -34}, },
            {{48, 75, -191}, {76, 76, 942}, {77, 122, -191}, },
            {{48, 82, -174}, {83, 83, 943}, {84, 122, -27}, },
            {{78, 78, 944}, },
            {{76, 76, 945}, },
            {{78, 78, 946}, },
            {{76, 76, 947}, },
            {{83, 83, 948}, },
            {{116, 116, 949}, },
            {{117, 117, 950}, },
            {{105, 105, 951}, },
            {},
            {{48, 83, -186}, {84, 84, 952}, {85, 122, -186}, },
            {{48, 68, -28}, {69, 69, 953}, {70, 122, -40}, },
            {{48, 83, -186}, {84, 84, 954}, {85, 122, -186}, },
            {{48, 68, -28}, {69, 69, 955}, {70, 122, -40}, },
            {{48, 122, -33}, },
            {{84, 84, 956}, },
            {{69, 69, 957}, },
            {{84, 84, 958}, },
            {{69, 69, 959}, },
            {},
            {{101, 101, 960}, },
            {{116, 116, 961}, },
            {{102, 102, 962}, },
            {{48, 82, -174}, {83, 83, 963}, {84, 122, -27}, },
            {{48, 82, -174}, {83, 83, 964}, {84, 122, -27}, },
            {{48, 82, -174}, {83, 83, 965}, {84, 122, -27}, },
            {{48, 82, -174}, {83, 83, 966}, {84, 122, -27}, },
            {{83, 83, 967}, },
            {{83, 83, 968}, },
            {{83, 83, 969}, },
            {{83, 83, 970}, },
            {{65, 90, 971}, {97, 122, 972}, },
            {{105, 105, 973}, },
            {{105, 105, 974}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {{48, 122, -33}, },
            {},
            {},
            {},
            {},
            {{65, 122, -962}, },
            {{65, 122, -962}, },
            {{111, 111, 975}, },
            {{101, 101, 976}, },
            {{110, 110, 977}, },
            {{114, 114, 978}, },
            {{65, 90, 979}, {97, 122, 980}, },
            {{65, 90, 981}, {97, 122, 982}, },
            {{65, 122, -979}, },
            {{65, 122, -979}, },
            {{65, 122, -980}, },
            {{65, 122, -980}, },
        }
        { // SHEBANG
            {{0, 9, 1}, {10, 10, 2}, {11, 12, 1}, {13, 13, 2}, {14, 32, 1}, {33, 34, 3}, {35, 35, 4}, {36, 126, 3}, {127, 160, 1}, {161, 8205, 3}, {8206, 8207, 1}, {8208, 8231, 3}, {8232, 8233, 1}, {8234, 65535, 3}, },
            {{0, 9, 5}, {11, 12, 5}, {14, 32, 5}, {127, 160, 5}, {8206, 8207, 5}, {8232, 8233, 5}, },
            {},
            {},
            {{33, 33, 6}, },
            {{0, 8233, -3}, },
            {},
        }
        { // COMMENT
            {{0, 9, 1}, {10, 10, 2}, {11, 12, 1}, {13, 13, 2}, {14, 32, 1}, {33, 41, 3}, {42, 42, 4}, {43, 46, 3}, {47, 47, 5}, {48, 126, 3}, {127, 160, 1}, {161, 8205, 3}, {8206, 8207, 1}, {8208, 8231, 3}, {8232, 8233, 1}, {8234, 65535, 3}, },
            {{0, 9, 1}, {10, 10, 3}, {11, 12, 1}, {13, 13, 3}, {14, 41, -2}, {43, 46, 3}, {48, 65535, -2}, },
            {{0, 41, 3}, {43, 46, 3}, {48, 65535, 3}, },
            {{0, 65535, -4}, },
            {{47, 47, 6}, },
            {{42, 42, 7}, },
            {},
            {},
        }
    };*/

    private static int[][] accept;
/*  {
        // NORMAL
        {-1, 245, 245, 9, -1, 10, 11, 12, 13, 14, 15, 16, 17, 19, 22, 23, 27, 30, 242, 242, 38, 41, 42, 53, 56, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 138, 35, 139, 142, 244, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 198, 200, 199, 205, 169, -1, 17, 12, 28, 105, 113, 95, 24, 44, 25, 58, 202, 55, 51, 20, 9, 10, 197, 38, 31, 23, 201, 13, 170, 36, 140, 205, 34, 50, 62, 48, 33, 47, 32, 61, 127, 85, 96, 128, 203, 52, 21, 57, 60, 49, 204, 206, 207, 208, 43, -1, 8, 0, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 18, -1, -1, 26, -1, -1, 29, 28, 3, 31, -1, 34, 36, -1, -1, 39, 40, -1, -1, 43, 45, 47, -1, 50, 137, 52, 54, 55, -1, -1, 61, 62, 237, 237, 237, 237, 237, 237, 237, 68, 237, 237, 237, 237, 237, 79, 237, 237, 237, 237, 237, 237, 237, 88, 237, 91, 237, 237, 237, 237, 237, 237, 109, 237, 111, 112, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, -1, -1, 137, 140, -1, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 157, 237, 237, 237, 237, 237, 237, 237, 237, 237, 170, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, -1, -1, 197, -1, 203, 201, -1, -1, 29, 106, 114, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 20, 24, 32, -1, 37, 243, 46, 44, -1, 48, 49, 51, 57, 58, 237, 65, 237, 237, 237, 237, 237, 237, 237, 237, 237, 83, 237, 237, 237, 86, 237, 237, 237, 94, 237, 98, 237, 237, 237, 237, 237, 105, 237, 113, 115, 237, 237, 237, 237, 123, 237, 237, 237, 237, 237, 237, 237, 237, 131, 237, 237, 141, 237, 237, 144, 237, 237, 237, 237, 237, 152, 237, 237, 155, 237, 237, 237, 237, 237, 237, 237, 165, 166, 237, 168, 169, 237, 237, 237, 237, 178, 179, 180, 181, 237, 183, 237, 237, 189, 237, 237, 237, 237, 194, 237, 237, 202, 204, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 21, 25, 33, 207, 206, 59, 60, 237, 237, 237, 70, 72, 237, 237, 237, 237, 237, 81, 237, 237, 237, 237, 87, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 237, 106, 237, 237, 114, 237, 237, 237, 120, 237, 122, 237, 237, 237, 126, 127, 237, 129, 237, 237, 134, 237, 237, 237, 237, 145, 237, 147, 237, 150, 237, 237, 237, 237, 237, 237, 160, 237, 163, 164, 237, 171, 237, 173, 237, 175, 176, 177, 237, 184, 186, 187, 188, 237, 237, 192, 193, 195, 237, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 231, 232, -1, 233, -1, -1, -1, -1, -1, 208, 237, 237, 69, 237, 237, 237, 237, 237, 82, 237, 237, 85, 237, 237, 237, 237, 237, 96, 237, 237, 237, 237, 237, 101, 237, 237, 237, 237, 237, 237, 124, 237, 237, 128, 237, 237, 135, 136, 143, 237, 146, 237, 151, 237, 154, 156, 158, 159, 161, 237, 237, 237, 237, 182, 185, 237, 237, 196, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 237, 66, 73, 237, 237, 237, 237, 80, 110, 237, 237, 237, 237, 237, 237, 237, 237, 237, 103, 104, 237, 237, 237, 237, 237, 121, 125, 102, 130, 237, 237, 71, 237, 153, 237, 167, 237, 174, 190, 237, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 235, -1, -1, -1, -1, 237, 237, 237, 237, 237, 237, 84, 237, 90, 237, 237, 95, 237, 237, 100, 107, 237, 237, 237, 237, 118, 237, 132, 148, 162, 172, 191, -1, -1, -1, -1, -1, -1, -1, 222, 211, 223, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 237, 237, 237, 237, 237, 237, 237, 92, 237, 237, 237, 108, 237, 116, 237, 237, 237, 149, -1, -1, -1, -1, -1, -1, -1, 224, -1, -1, -1, -1, -1, -1, 229, -1, -1, -1, -1, -1, -1, 237, 237, 237, 76, 237, 237, 237, 237, 237, 97, 237, 237, 237, 237, 133, -1, -1, -1, 218, -1, -1, -1, -1, 226, -1, -1, 236, 210, -1, -1, 234, -1, -1, -1, -1, 237, 237, 67, 237, 237, 237, 237, 237, 237, 237, 237, 110, 117, 119, -1, -1, 215, -1, -1, -1, 221, 209, -1, -1, 228, 230, -1, -1, -1, -1, -1, 237, 237, 237, 237, 77, 78, 237, 237, 237, 237, -1, -1, -1, -1, 219, 220, -1, -1, -1, -1, -1, -1, -1, 237, 237, 237, 237, 237, 237, 237, 237, -1, -1, -1, -1, -1, -1, 212, -1, -1, -1, -1, 237, 237, 237, 237, 237, 237, 237, 237, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 237, 237, 237, 237, 89, 93, 93, 237, -1, -1, -1, -1, 225, -1, -1, -1, -1, -1, 237, 237, 237, 237, 237, -1, -1, -1, -1, -1, -1, -1, -1, 241, 237, 237, 237, 237, 99, -1, -1, -1, -1, 227, -1, -1, -1, 237, 237, 237, 237, -1, -1, -1, -1, 239, -1, -1, 63, 64, 74, 75, 213, 214, 216, 217, 239, 239, -1, -1, -1, -1, 238, 240, 238, 238, 240, 240, },
        // SHEBANG
        {-1, 2, 1, 2, 2, 245, 0, },
        // COMMENT
        {5, 5, 5, 5, 6, 7, 4, 3, },

    };*/

    public static class State
    {
        public final static State NORMAL = new State(0);
        public final static State SHEBANG = new State(1);
        public final static State COMMENT = new State(2);

        private int id;

        private State(  int id)
        {
            this.id = id;
        }

        public int id()
        {
            return this.id;
        }
    }

    static 
    {
        try
        {
            DataInputStream s = new DataInputStream(
                new BufferedInputStream(
                Lexer.class.getResourceAsStream("lexer.dat")));

            // read gotoTable
            int length = s.readInt();
            gotoTable = new int[length][][][];
            for(int i = 0; i < gotoTable.length; i++)
            {
                length = s.readInt();
                gotoTable[i] = new int[length][][];
                for(int j = 0; j < gotoTable[i].length; j++)
                {
                    length = s.readInt();
                    gotoTable[i][j] = new int[length][3];
                    for(int k = 0; k < gotoTable[i][j].length; k++)
                    {
                        for(int l = 0; l < 3; l++)
                        {
                            gotoTable[i][j][k][l] = s.readInt();
                        }
                    }
                }
            }

            // read accept
            length = s.readInt();
            accept = new int[length][];
            for(int i = 0; i < accept.length; i++)
            {
                length = s.readInt();
                accept[i] = new int[length];
                for(int j = 0; j < accept[i].length; j++)
                {
                    accept[i][j] = s.readInt();
                }
            }

            s.close();
        }
        catch(Exception e)
        {
            throw new RuntimeException("The file \"lexer.dat\" is either missing or corrupted.");
        }
    }
}
